<template>
  <base-card>
    <base-button
        :mode="setFlatClassStore"
        @click="setActiveComponent('stored-resource')">Stored resources</base-button>
    <base-button
        :mode="setFlatClassAdd"
        @click="setActiveComponent('add-resource')">Add resource</base-button>
  </base-card>
  <component :is="activeComponent"></component>
</template>

<script>
import StoredResource from "./StoredResource";
import AddResource from "./AddResource";

export default {
  name: "TheResources",
  components: {
    StoredResource,
    AddResource,
  },
  data(){
    return {
      activeComponent: 'stored-resource',
      storedResources: [
        {
          'id': 'Original Resource',
          'title': 'Original Resource',
          'description': 'This the original resource description',
          'link': 'https://vuejs.org'
        },
        {
          'id': 'Make search',
          'title': 'Make search on internet',
          'description': 'A great tool to make search on internet more efficiently.',
          'link': 'https://google.com'
        },
      ]
    };
  },
  provide(){
    return {
      resources: this.storedResources,
      addResource: this.addResource,
      removeResource: this.removeResource
    };
  },
  computed:{
    setFlatClassAdd(){
      return this.activeComponent === 'add-resource' ? null : 'flat';
    },
    setFlatClassStore(){
      return this.activeComponent === 'stored-resource' ? null : 'flat';
    },
  },
  methods: {
    setActiveComponent(cmp) {
      this.activeComponent = cmp;
    },

    addResource(title,desc,link){
      const newResource = {
        id: new Date().toISOString(),
        title: title,
        description: desc,
        link: link
      }
      this.storedResources.unshift(newResource);
      this.activeComponent = 'stored-resource';
    },
    removeResource(id){
      const resIndex = this.storedResources.findIndex(res => res.id == id);
      this.storedResources.splice(resIndex,1)
    }
  }
}
</script>

<style scoped>

</style>